<template>
  <div class="contract-tarification-container">
    <ObTable
      ref="serviceTable"
      :columns="columns"
      :functional-panel="true"
      :page-limit="15"
      :remote-opt="{
        method: api.contract.getContractServices,
        arguments: {
          uuid: $route.params.id,
          caste: selectedTab.uuid
        }
      }"
      :remote-trigger="selectedTab.uuid"
      :show-add-button="isDraft"
      data-qa="tarificationTable"
      @add="onAddService"
      @select="onSelectService"
    >
      <div slot="resourceType" slot-scope="{ data }">
        <div class="resource-type">
          <div class="resource-type__icon">
            <i
              class="icon isothermal-van-b-g"
            />
          </div>
          <div class="resource-type__desc">
            {{ data.item.resourceSpeciesTitle }}<br>
            {{ data.item.resourceSubtypeTitle }}. {{ data.item.resourcePatternParameter }}
          </div>
        </div>
      </div>
      <div slot="dropdownMenu" slot-scope="{ data }">
        <ObMenuDropdown
          :items="getDropdownItems(data)"
        />
      </div>
      <template slot="noneContent">
        <div class="title">
          <template v-if="selectedTab.uuid === 'SIMPLE'">
            Здесь вы сможете настраивать тарифы для ваших<br/>перевозок. Для этого добавьте хотя бы одну услугу.
          </template>
          <template v-if="selectedTab.uuid === 'ADDITIONAL'">
            <!--Здесь вы можете добавить и тарифицировать<br>дополнительные услуги-->
          </template>
          <template v-if="selectedTab.uuid === 'MULTISTOP'">
            <!--Здесь вы сможете добавить и тарифицировать<br>мультистоповые услуги.-->
          </template>
        </div>
        <ObButton
          v-if="isDraft"
          label="Добавить услугу"
          type="flat"
          data-qa="addService"
          @click="onAddService"
        />
      </template>
      <template v-slot:extraFuncToPanel>
        <div class="contract-tarification-container-functional">
          <div class="contract-tarification-container__select-inline" :class="['disabled']">
            <span>Группировать: </span>
            <ob-inline-select
              v-model="listFilter.uuid"
              :items="listFilters"
            />
          </div>
          <ObSwitcher
            v-model="switcher"
            label-right="Скрывать неактивные направления"
          />
        </div>
      </template>
    </ObTable>
    <component
      :is="currentServiceModal"
      ref="serviceModal"
      data-qa="tarificationService"
      :data-source="editedService"
      :title-second="titleSecondModal"
      :title="titleModal"
      @on-delete="deleteService"
      @submit="onSaveService"
    />
  </div>
</template>

<script>
  import {mapGetters} from 'vuex'
  import api from '@/api'
  import ObInlineSelect from 'common-components/src/obComponents/obInlineSelect'
  import ObSwitcher from "common-components/src/obComponents/obSwitcher"
  import ObTable from 'common-components/src/obComponents/obTable'
  import ObButton from 'common-components/src/obComponents/obButton'
  import TransportationBaseServiceModal from '@/components/Contract/detail/services/TransportationBaseModal'
  import TransportationAdditionalModal from '@/components/Contract/detail/services/TransportationAdditionalModal'
  import TransportationMultistopModal from '@/components/Contract/detail/services/TransportationMultistopModal'
  import ContractDetailMixin from '@/components/Contract/detail/contract-detail-mixin'
  import ObMenuDropdown from 'common-components/src/obComponents/obMenuDropdown'

  export default {
    name: 'ContractDetailTarification',
    mixins: [
      ContractDetailMixin
    ],
    components: {
      ObInlineSelect,
      ObSwitcher,
      ObTable,
      TransportationBaseServiceModal,
      TransportationAdditionalModal,
      TransportationMultistopModal,
      ObMenuDropdown,
      ObButton
    },
    data () {
      return {
        api,
        editedService: null,
        selectedTab: {
          uuid: 'MULTISTOP',
          title: 'Мультистоповые'
        },
        listFilter: {
          uuid: 'typeService'
        },
        listFilters: [
          {
            uuid: 'typeService',
            title: 'По типу услуги'
          },
          {
            uuid: 'typeResource',
            title: 'По типу ресурсов'
          },
          {
            uuid: 'units',
            title: 'По ед. измерения'
          },
          {
            uuid: 'additionalPoint',
            title: 'По допточке'
          },
          {
            uuid: 'run',
            title: 'По допробегу'
          },
          {
            uuid: 'vat',
            title: 'По НДС'
          }
        ],
        switcher: false,
        tabsItems: [
          {
            uuid: 'SIMPLE',
            title: 'Базовые услуги'
          },
          {
            uuid: 'MULTISTOP',
            title: 'Мультистоповые'
          },
          // {
          //   uuid: 'MULTIMODAL',
          //   title: 'Мультимодальные',
          //   isDisabled: true
          // },
          {
            uuid: 'ADDITIONAL',
            title: 'Дополнительные'
          }
        ]
      }
    },
    watch: {
      'selectedTab.uuid' () {
        if (this.$refs.serviceTable) {
          this.$refs.serviceTable.localItems = []
        }
      }
    },
    computed: {
      ...mapGetters({
        isDraft: 'contract/isDraft',
        isVatPayer: 'contract/isDoerVatPayer'
      }),
      currentServiceModal () {
        const componentsMap = {
          SIMPLE: TransportationBaseServiceModal,
          ADDITIONAL: TransportationAdditionalModal,
          MULTISTOP: TransportationMultistopModal
        }

        return componentsMap[this.selectedTab.uuid]
      },
      columns () {
        return [
          {
            title: 'Услуга',
            key: 'serviceTypeTitle',
            html: (data) => data.resourceSpeciesTitle
              ? `${data.serviceTypeTitle}. ${data.resourceSpeciesTitle}. ${data.resourceSubtypeTitle} ${data.resourcePatternParameter}`
              : `${data.serviceTypeTitle}`
          },
          {
            title: 'Единица измерения',
            key: 'serviceUnitTitle'
          },
          {
            title: 'Кол-во маршрутов',
            key: 'directionsCount',
            html: (data) => data.directionsCount || 0
          },
          {
            title: ' ',
            slotName: 'dropdownMenu',
            width: 90,
            action: true
          }
        ]
      },
      titleModal () {
        return this.editedService && this.selectedTab.uuid !== 'MULTISTOP' ? this.getServiceTitle(this.editedService) : this.serviceTitleByType
      },
      serviceTitleByType () {
        let titleMap = {
          SIMPLE: 'Базовая услуга',
          MULTISTOP: 'Мультистоповая услуга',
          MULTIMODAL: 'Мультимодальная услуга',
          ADDITIONAL: 'Дополнительная услуга',
        }
        return titleMap[this.selectedTab.uuid]
      },
      titleSecondModal () {
        if (!this.isDraft) {
          return 'Просмотр'
        }
        return this.editedService ? 'редактирование' : 'добавление'
      }
    },
    methods: {
      getServiceTitle (object, isShort = false) {
        let {
          serviceTypeTitle,
          resourcePatternParameter,
          resourceSubtypeTitle,
          resourceSpeciesTitle,
          serviceUnitTitle
        } = object || {}

        const serviceTitle = resourceSpeciesTitle ? `${serviceTypeTitle}. ${resourceSpeciesTitle}. ${resourceSubtypeTitle} ${resourcePatternParameter}. ${serviceUnitTitle}` : `${serviceTypeTitle}. ${serviceUnitTitle}`

        if (isShort) {
          return serviceTitle
        }

        return `${this.serviceTitleByType} «${serviceTitle}»`
      },
      onAddService () {
        this.editedService = null
        this.$refs.serviceModal.open()
      },
      async editService ({ uuid, isVatInclude }) {
        try {
          let data = await api.contract.getServiceDetail({ uuid })
          this.editedService = {
            ...data,
            isVatInclude,
            isNds: data.vatValue !== null,
            vatTypeUuid: 'b849dddf-63e1-4dc6-a00d-a9b7b3d15f53',
            uuid
          }
          this.$refs.serviceModal.open()
        } catch (e) {
          this.$notification({
            type: 'system_notification_error',
            message: `Не удалось загрузить данные услуги`
          })
        }
      },
      onSelectService (data) {
        if (data.geography === 'WITHOUT_GEOGRAPHY_BINDING') {
          return false
        }
        this.setEditedService({type: this.selectedTab.uuid, ...data, serviceTitle: this.getServiceTitle(data, true)})
        this.$nextTick(() => {
          this.setViewState(this.VIEW_STATES.serviceDetail)
        })
      },
      async deleteService ({ uuid, serviceCaste }) {
        this.$refs.serviceModal.close()
        try {
          await api.contract.deleteService({uuid, serviceCaste })
          this.$notification({
            type: 'system_notification_success',
            message: `Услуга удалена`
          })
          setTimeout(() => {
            this.calcExistServices({ data: this.contract })
            this.$refs.serviceTable.loadData()
          }, 2000)
        } catch (e) {
          this.$notification({
            type: 'system_notification_error',
            message: `Ошибка удаления услуги`
          })
        }
      },
      async onSaveService ({ formData }) {
        let data = { ...formData }
        let isUpdate = Boolean(this.editedService && this.editedService.uuid)
        let serviceUuid
        try {
          if (isUpdate) {
            await this.updateService(data)
          } else {
            serviceUuid = await this.createService(data)
          }
          this.$notification({
            type: 'system_notification_success',
            message: `Услуга ${this.editedService ? 'обновлена' : 'добавлена'}`
          })
          this.$refs.serviceModal.close()
          this.setExistServices(true)
          setTimeout(() => {
            this.$refs.serviceTable.loadData({init: true})
            if (!isUpdate) {
              this.$refs.serviceTable.$once('on-load-list', (list) => {
                let service = list.find((item) => item.uuid === serviceUuid)
                service && this.onSelectService(service)
              })
            }
          }, 2000)
        } catch (e) {
          this.$notification({
            type: 'system_notification_error',
            message: `Ошибка ${this.editedService ? 'обновления' : 'добавления'} услуги`
          })
        }
      },
      async createService (data) {
        try {
          data.contractUuid = this.contract.uuid
          return await api.contract.createService({ data, serviceCaste: this.caste })
        } catch (e) {
          throw e
        }
      },

      async updateService (data) {
        await api.contract.updateService({ data, uuid: this.editedService.uuid })
        setTimeout(() => {
          this.$refs.serviceTable.loadData()
        }, 1000)
      },
      getDropdownItems (data) {
        if (!this.isDraft) {
          return [
            {
              title: 'Просмотр услуги',
              method: () => this.editService(data.item)
            }
          ]
        }
        return [
          {
            title: 'Настроить услугу',
            method: () => this.editService(data.item)
          },
          {
            title: 'Удалить услугу',
            className: 'menu-button-danger',
            method: () => this.deleteService(data.item)
          }
        ]
      }
    }
  }
</script>

<style lang="scss" scoped>
  @import "~common-components/src/static/css/mixins";

  .contract-tarification-container {
    display: flex;
    flex-direction: column;
    height: 100%;

    .header-block {
      position: relative;
      padding: 20px 20px 0 20px;

      &:before {
        content: '';
        display: block;
        width: 100%;
        height: 15px;
        position: absolute;
        z-index: 100;
        bottom: -15px;
        left: 0;
        pointer-events: none;
        background: linear-gradient(to bottom, rgba($color-blue-navy-blue, 0.08) 0%, rgba($color-blue-navy-blue, 0) 100%);
      }

      .main-title {
        margin-bottom: 30px;
      }
    }

    &-functional {
      display: flex;
      align-items: center;
      flex: 1;
    }

    &__select-inline {
      padding: 7px 12px;
      margin-right: 12px;
      background: $lavender;
      border-radius: 19px;

      &.disabled {
        background: $color-white-lilac;
        pointer-events: none;
      }

      span {
        font-size: 14px;
        line-height: 18px;
        letter-spacing: 0.2px;
        color: $color-grey-span;
      }
    }

    &::v-deep {
      .ob-tabs__sliding-line {
        bottom: 0;
      }
      .ob-func-panel {
        padding-top: 1px;
        background-color: transparent;
      }
    }

    .main-title, .sub-title {
      display: flex;
      justify-content: flex-start;
      align-items: center;
      margin-bottom: 10px;

      .ob-validate-state-container {
        margin-left: 5px;
      }
    }

    .main-title {
      @include font-mixin(20px, 28px, 600, $color-text-base, 0.4px);
    }

    .sub-title {
      margin-bottom: 10px;
      @include font-mixin(16px, 24px, 600, $color-text-base, 0.4px);
    }

    .resource-type {
      display: flex;
      align-items: center;

      &__icon {
        display: flex;
        align-items: center;
        justify-content: flex-end;
        width: 70px;
        margin-right: 22px;

        .icon {
          font-size: 24px;
          color: $color-grey-span;
        }
      }

      &__desc {
        font-family: Roboto, sans-serif;
        font-style: normal;
        font-weight: normal;
        font-size: 12px;
        line-height: 17px;
      }
    }
  }
  ::v-deep .ob-func-panel{
    &__controls{
      justify-content: flex-start;
      &-side{
        &:last-child{
          width: 100%;
          .ob-func-panel__control{
            &:first-child{
              width: 100%;
            }
          }
        }
      }
    }
  }
</style>

<style lang="scss">
  @import '~common-components/src/static/css/variables';

  .contract-tarification-container {
    table {
      min-width: auto !important;
    }

    .menu-button-danger {
      button {
        color: $color-error;
        .icon {
          color: $color-error!important;
        }
      }
    }

    .ob-table-inner {
      flex-grow: 2;

      td:first-child {
        .td-container {
          color: $color-blue-navy-blue;
        }
      }

      .ob-menu-dropdown-container:not(.--opened) {
        opacity: 0;
        pointer-events: none;
      }

      td {
        &:last-child {
          .td-container {
            justify-content: flex-end;
          }
        }
      }

      tr:hover {
        .ob-menu-dropdown-container {
          opacity: 1;
          pointer-events: all;
        }

        .resource-type {
          &__icon {
            .icon {
              color: $color-blue-navy-blue;
            }
          }
        }
      }
    }

    .ob-table-inner.tb_showMore:before {
      z-index: 10 !important;
    }

    .ob-func-panel {
      &__control-row {
        background-color: transparent;
      }
    }
  }
</style>
